/*

Copyright (C) 2012  Observatoire de Paris

The JavaScript code in this page is free software: you can
redistribute it and/or modify it under the terms of the GNU
General Public License (GNU GPL) as published by the Free Software
Foundation, either version 3 of the License, or (at your option)
any later version.  The code is distributed WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU GPL for more details.

As additional permission under GNU GPL version 3 section 7, you
may distribute non-source (e.g., minimized or compacted) forms of
that code without the copy of the GNU GPL normally required by
section 4, provided you include this license notice and a URL
through which recipients can access the Corresponding Source.

*/

function SelectionDlg(question, minsel, maxsel, listeImages, fct_suite) {
    var that;
    
    this.question = question;
    this.minsel = minsel;
    this.maxsel = maxsel;
    this.listeImages = listeImages;
    this.fct_suite = fct_suite;
    
    that = this;
    this.proxyAnnulation = function(e) { that.annuler(); };
    this.proxyValidation = function(e) { e.preventDefault(); that.valider(); return(false); };
}

SelectionDlg.prototype.afficher = function() {
    var div, h2, p, formulaire, div_choix_images, i, inputs, label, div_boutons, bannuler, bok;
    
    div = document.getElementById('div-selection');
    if (div.firstChild != null) {
        while (div.hasChildNodes())
            div.removeChild(div.lastChild);
    }
    
    h2 = document.createElement('h2');
    h2.appendChild(document.createTextNode(Messages.get("Sélection_images")));
    div.appendChild(h2);
    
    p = document.createElement('p');
    p.appendChild(document.createTextNode(this.question));
    div.appendChild(p);
    
    formulaire = document.createElement('form');
    formulaire.setAttribute('autocomplete', 'off');
    formulaire.addEventListener('submit', this.proxyValidation, false);
    div_choix_images = document.createElement('div');
    div_choix_images.setAttribute('id', 'div-choix-images');
    this.inputs = new Array(this.listeImages.length);
    for (i=0; i<this.listeImages.length; i++) {
        this.inputs[i] = document.createElement('input');
        this.inputs[i].setAttribute('id', 'image' + i);
        this.inputs[i].setAttribute('type', 'checkbox');
        this.inputs[i].setAttribute('name', 'images');
        this.inputs[i].setAttribute('value', '' + i);
        div_choix_images.appendChild(this.inputs[i]);
        label = document.createElement('label');
        label.setAttribute('for', 'image' + i);
        label.appendChild(document.createTextNode(this.listeImages[i].getNom()));
        div_choix_images.appendChild(label);
        div_choix_images.appendChild(document.createElement('br'));
    }
    formulaire.appendChild(div_choix_images);
    
    div_boutons = document.createElement('div');
    div_boutons.setAttribute('id', 'div-boutons');
    
    bannuler = document.createElement('button');
    bannuler.setAttribute('id', 'annuler');
    bannuler.setAttribute('type', 'button');
    bannuler.appendChild(document.createTextNode(Messages.get("Annuler")));
    bannuler.addEventListener('click', this.proxyAnnulation, false);
    div_boutons.appendChild(bannuler);
    
    bok = document.createElement('button');
    bok.setAttribute('id', 'ok');
    bok.setAttribute('type', 'submit');
    bok.appendChild(document.createTextNode(Messages.get("OK")));
    div_boutons.appendChild(bok);
    
    formulaire.appendChild(div_boutons);
    div.appendChild(formulaire);
    
    div_overlay = document.getElementById('div-overlay-selection');
    div_overlay.style.display = 'block';
}

SelectionDlg.prototype.annuler = function() {
    this.continuer(null);
}

SelectionDlg.prototype.valider = function() {
    var indices, i;
    
    indices = new Array();
    for (i=0; i<this.listeImages.length; i++) {
        if (this.inputs[i].checked)
            indices.push(this.inputs[i].value);
    }
    if (indices.length < this.minsel) {
        alert(Messages.get('Sélectionner_au_moins') + ' ' + this.minsel + ' ' + Messages.get('images'));
        return;
    } else if (indices.length > this.maxsel) {
        alert(Messages.get('Sélectionner_au_plus') + ' ' + this.maxsel + ' ' + Messages.get('images'));
        return;
    }
    this.continuer(indices);
}

SelectionDlg.prototype.continuer = function(indices) {
    var div_overlay;
    
    div_overlay = document.getElementById('div-overlay-selection');
    div_overlay.style.display = 'none';
    this.fct_suite(indices);
}
